
#include"CCom.h"

enum boolean {
    true = 1, false = 0
};

typedef enum boolean  bool;

HANDLE   m_hCom;
DCB      PortDCB;
 

BOOL OpenSerialPort(char *cPortName)
{
  m_hCom = CreateFile (cPortName ,// Pointer to the name of the port
                      GENERIC_READ | GENERIC_WRITE,
                                    // Access (read/write) mode
                      0,            // Share mode
                      NULL,         // Pointer to the security attribute
                      OPEN_EXISTING,// How to open the serial port
                      0,            // Port attributes
                      NULL);        // Handle to port with attribute
                                    // to copy

  // if fail to open the port, return FALSE.
  if ( m_hCom == INVALID_HANDLE_VALUE ) 
    // Could not open the port.
      return FALSE;

  PortDCB.DCBlength = sizeof (DCB);     

  return true;

}

DCB GetSerialPortState() {

	// Get the default port setting information.
	GetCommState (m_hCom, &PortDCB);
	return(PortDCB);

}

void SetSerialPortState(DCB dcb) {

	// Configure the port according to the specifications of the DCB structure.
	SetCommState(m_hCom,&dcb);

}

BOOL WriteSerialPort(char *buffer)
{
    DWORD dummy;
    if(buffer == NULL)
       return FALSE;
    
    
        WriteFile(  m_hCom, 
                    buffer, 
                    (DWORD)strlen(buffer), 
                    &dummy, 
                    0 
                 ); 

return true;

}

BOOL ReadSerialPort(char *buffer, unsigned int ByteCount)
{

    DWORD nBytesRead;
    if((ByteCount==0) || (buffer == NULL))
        return FALSE;

	BOOL res;

	res = ReadFile(m_hCom,buffer,(DWORD)ByteCount,&nBytesRead,NULL);


    if(!res || nBytesRead!=ByteCount)
        return FALSE;

    else return TRUE;

}

BOOL CloseSerialPort()
{

    if(CloseHandle(m_hCom)) return TRUE ;
    else return FALSE;

}
